;;============================
;; gdm_cmd_vieleck_2d.lsp
;; os / 02.06.2006 15:52
;;============================

(in-package  :GDM)
(use-package :OLI)

;=== Logical table ===
(sd-create-logical-table
     "Vieleck"
     :columns     '(:SW_UM)
     :columnNames (sd-multi-lang-string
                    '("Wrench Size")
                    :german
                    '("Schluesselweite")
                  );;sd-multi-lang-string
     :types       '(:length)
     :units       '(:mm)
     :contents  '(( (3.2 :mm) )
                  ( (3.5 :mm) )
                  ( (4.0 :mm) )
                  ( (4.5 :mm) )
                  ( (5.0 :mm) )
                  ( (5.5 :mm) )
                  ( (6.0 :mm) )
                  ( (7.0 :mm) )
                  ( (8.0 :mm) )
                  ( (9.0 :mm) )
                  ( (10.0 :mm) )
                  ( (11.0 :mm) )
                  ( (12.0 :mm) )
                  ( (13.0 :mm) )
                  ( (14.0 :mm) )
                  ( (15.0 :mm) )
                  ( (16.0 :mm) )
                  ( (17.0 :mm) )
                  ( (18.0 :mm) )
                  ( (19.0 :mm) )
                  ( (20.0 :mm) )
                  ( (21.0 :mm) )
                  ( (22.0 :mm) )
                  ( (23.0 :mm) )
                  ( (24.0 :mm) )
                  ( (25.0 :mm) )
                  ( (26.0 :mm) )
                  ( (27.0 :mm) )
                  ( (28.0 :mm) )
                  ( (30.0 :mm) )
                  ( (32.0 :mm) )
                  ( (34.0 :mm) )
                  ( (36.0 :mm) )
                  ( (41.0 :mm) )
                  ( (46.0 :mm) )
                  ( (50.0 :mm) )
                  ( (55.0 :mm) )
                  ( (60.0 :mm) )
                  ( (65.0 :mm) )
                  ( (70.0 :mm) )
                  ( (75.0 :mm) )
                  ( (80.0 :mm) )
                  );;contents
 );;sd-create-logical-table
;=== End Logical table ===

(sd-create-display-table
     "Vieleck"
     :tableTitle         (sd-multi-lang-string "Wrench Size" :german "Schluesselweite")
     :logicalTable       "Vieleck"
     :columns            '(:SW_UM)
     :applyColumns       '(:SW_UM)
     :displayHeight      220
     :filterStatusLine   nil
     :selectionMode      :single-row
     :applyAction        :default-tokens
);;sd-create-display-table


(sd-defdialog 'gdm-cmd-vieleck-2d-dialog
 :dialog-title (sd-multi-lang-string "Polygon" :german "Vieleck")
 :toolbox-button t
 :start_variable 'ECKZAHL
 :variables
 '(
    (BILD
      :value-type :image
      :image-file (format nil "~a/LISP/gdm_cmd_vieleck_2d.bmp" (oli::sd-convert-filename-from-platform (oli::sd-sys-getenv "SDCORPCUSTOMIZEDIR"))))
;	    :image-file "C:/ ... PFAD ANPASSEN ... /gdm_cmd_vieleck_2d.bmp" :image-width 140 :image-height 101 :image-alignment :center)

    (WP
      :value-type :wp
      :title (sd-multi-lang-string "Workplane" :german "AEbene")
      :prompt-text (sd-multi-lang-string "Specify Workplane." :german "Arbeitsebene angeben.")
      :initial-value (sd-inq-curr-wp) )

    (MPKT
      :value-type :point-2d
      :Title (sd-multi-lang-string "Center" :german "Mittelpunkt")
      :Prompt-text (sd-multi-lang-string "Specify Center." :german "Mittelpunkt angeben."))

    (ECKZAHL
      :value-type :positive-integer
      :title (sd-multi-lang-string "No. of Sides" :german "Seitenzahl")
      :prompt-text (sd-multi-lang-string "Specify Number of Sides." :german "Seitenzahl angeben.")
      :direction :input
      :initial-value 6)

    (SW_UM
      :value-type :positive-number
      :title "SW / UM"
      :prompt-text (sd-multi-lang-string "Specify Wrench Size or Cirumcircle." :german "Schluesselweite bzw. Umkreisdurchmesser angeben.")
      :show-input-tool (sd-show-display-table "Vieleck" :position '("TOP-MENU-TOOLBOX-TB" :bottomright 350 50))
      :hide-input-tool (sd-hide-display-table "Vieleck" :ignorePin t)
      :initial-value 10)

    (WINKEL
      :value-type :angle
      :title (sd-multi-lang-string "Angle" :german "Winkel")
      :prompt-text (sd-multi-lang-string "Specify Angle." :german "Winkel angeben.")
      :initial-value 0)

    (DUMY_TEXT1 :title (sd-multi-lang-string "In-Circle / Circumcircle" :german "Inkreis / Umkreis"))
    (INKR
      :value-type :boolean
      :title (sd-multi-lang-string "SW  In-Circle" :german "SW Inkreis-Durchmesser")
      :toggle-type :wide-toggle
      :initial-value t)
    (UMKR
      :value-type :boolean
      :title (sd-multi-lang-string "UM  Cirumcircle" :german "UM Umkreis-Durchmesser")
      :toggle-type :wide-toggle)

    (DUMY_TEXT2 :title (sd-multi-lang-string "Construction Circle" :german "Hilfsgeometrie Kreis"))
    (HGEO_Y
      :value-type :grouped-boolean
      :title (sd-multi-lang-string "with" :german "mit"))

    (HGEO_N
      :value-type :grouped-boolean
      :title (sd-multi-lang-string "without" :german "ohne")
      :initial-value t)

    ("")
    (next
      :push-action (os-vieleck-2d-erstellen)
      :toggle-type :wide-toggle
      :after-input (setf MPKT nil)
      :next-variable 'MPKT)
 );;variables

 :mutual-exclusion '((INKR UMKR) (HGEO_Y HGEO_N))

 :local-functions
 '(
   (os-vieleck-2d-erstellen ()
    (sd-call-cmds
     (progn
      (let (RAD_ID ALFAP ALFAS ALFAB ALFAC Counter X0 X1 XP Y0 Y1 YP)
        (setq RAD_ID (/ SW_UM 2))
        (if HGEO_Y
           (sd-call-cmds (c_circle :radius RAD_ID MPKT))
        )
        (setq ALFAP (/ (- 180 (/ 360 ECKZAHL)) 2))
        (setq ALFAS (/ 360 ECKZAHL))
        (setq ALFAB (+ ALFAP (/ (* WINKEL 360) (* pi 2))))
        (if INKR
            (setq RAD_ID (/ RAD_ID (sin (sd-deg-to-rad ALFAP))))
        );;if

        (dotimes (Counter ECKZAHL)
          (setq ALFAC (+ ALFAB (* ALFAS counter)))
          (setq X1 (* RAD_ID (cos (sd-deg-to-rad ALFAC) )))
          (setq Y1 (* RAD_ID (sin (sd-deg-to-rad ALFAC) )))
          (setq X1 (+ X1 (gpnt2d_x MPKT)))
          (setq Y1 (+ Y1 (gpnt2d_y MPKT)))
          (cond
            ((> Counter 0)
             (geometry_mode :real)
             (sd-call-cmds (line :two_points (make-gpnt2d :x X0 :y Y0) (make-gpnt2d :x X1 :y Y1)))
            )
            ((= Counter 0)
             (setq XP X1)
             (setq YP Y1)
            )
          );;cond
          (setq X0 X1)
          (setq Y0 Y1)
        );;dotimes
        (geometry_mode :real)
        (sd-call-cmds (line :two_points (make-gpnt2d :x X0 :y Y0) (make-gpnt2d :x XP :y YP)))
      );;let
     );;progn
    );;sd-call-cmds
   );;os-vieleck-2d-erstellen
 );;local-functions

 :ok-action '(os-vieleck-2d-erstellen)

);;sd-defdialog
